import os
import re
f = []
for root, dirs, files in os.walk("./synfig-docs/source"):
    for file in files:
        if file.endswith(".rst"):
             f.append(os.path.join(root, file).replace("\\","/"))

maps = open("maps.txt", "w")
for fileLocation in f:
    with open(fileLocation, encoding="utf8") as file:
        for l in re.findall(r"((`(?!_)([^`])+<)(\w+|\w+#([^>`])+)(>`__))", file.read()):
            s = str(l[0])
            s = re.sub(r"(`(?!_)([^`])+<)(\w+|\w+#([^>`])+)(>`__)", '|\\3|', s )
            s = re.sub('\|(\w+)\#(\w+|\w+( (\w+))+)\|', '|\\1_\\2|', s)
            maps.write(s + '\n')
            print(s)


maps.close()
maps = open("maps.txt")
lines = maps.readlines()
mylist = list(dict.fromkeys(lines))
maps.close()
maps = open("maps.txt", "w")
maps.write(''.join(mylist))
maps.close()